#include rom86.h
#include ram86.h
#include flag86.inc
#define rel(x) x-$-1

;uber relocation program
;if done from in a shell, screwy things can happen...
;	hence the _jforce

.org _asm_exec_ram

	nop
	jp load_start
	.dw 2
	.dw load_title
	.dw load_icon
	.dw load_dtinfo
load_title:
	.db "Blinded by the Dark v1.2",0

;*******************************************
;***** stuff to show save files in YAS *****
;*******************************************

load_dtinfo:
	.db 1
	.dw bsv_dt_info

bsv_dt_info:
	.db 4
	.db $0c
	.db "bsv"

	.dw bsv_dt_exec

	.dw bsv_dt_enddetect-bsv_dt_detect
	.dw rel(bsv_dt_detect)

	.dw bsv_dt_endcomment-bsv_dt_comment
	.dw rel(bsv_dt_comment)

	.dw bsv_dt_endicon-bsv_dt_icon
	.dw rel(bsv_dt_icon)

bsv_dt_exec:
	call _OP1TOOP6
	set ex_asm_module,(iy+anumeditflgs)
	jr load_start

bsv_dt_detect:
	call _get_word_ahl
	call _get_word_ahl
	ld hl,('s'*256)+$fe
	or a
	sbc hl,de
	ret z
	scf
	ret
bsv_dt_enddetect:

bsv_dt_comment:
	ld hl,$f400+bsv_default_comment-bsv_dt_comment
	or a
	ret
bsv_default_comment:
	.db "BbtD Save File",0
bsv_dt_endcomment:

bsv_dt_icon:
	ld hl,$f400+load_icon-bsv_dt_icon
	ld c,(hl)
	inc hl
	ld b,(hl)
	inc hl
	or a
	ret

load_icon:
	.db 8,1
	.db %01111000
	.db %01111100
	.db %00010010
	.db %00010000
	.db %00010000
	.db %10010000
	.db %01111100
	.db %00111100
bsv_dt_endicon:

;***********************************
;***** Start of actual program *****
;***********************************

load_start:
	call _flushallmenus
	call _runindicoff
	call _clrLCD
	ld hl,0
	ld (_penCol),hl
	ld (_asapvar),hl
	ld hl,load_waitmessage
	call _vputs

	;check for file...
	ld hl,load_name-1
	rst 20h
	rst 10h
	ret c
	ex de,hl
	ld a,b
	call _get_word_ahl
	call _get_word_ahl
	ld hl,$329f
	or a
	sbc hl,de
	ret nz
	rst 10h

	ld a,1
	ld hl,$4000
	call _cp_ahl_bde
	scf
	jp z,load_donereloc

	di			;need to stop iShell users from breaking this

	ex de,hl
	ld a,b
	ld (load_startpage+1),a
	ld (load_startaddress+1),hl
	push hl
	push af
	call _get_word_ahl
	inc de
	inc de
	ld (load_filelength+1),de
	pop af
	pop hl
	call _load_ram_ahl
	push af
	push hl
	call _RAM_PAGE_1
	out (5),a
	ld de,-$4000
	add hl,de

	;** stage 1 -- copy ~15k (max) chunk to free memory **
	ld bc,(load_filelength+1)
	ld de,$8010
load_copyloop:
	ld a,h
	add a,a
	jr nc,load_pageok
	ld h,$40
	in a,(5)
	inc a
	out (5),a
load_pageok:
	ldi
	jp pe,load_copyloop

	;** stage 2 -- shift memory up by length of file **
	ex de,hl
	pop hl
	pop af
	out (6),a
	dec de
	dec hl
load_shiftloop:
	bit 7,h
	jr nz,load_sourceok
	ld h,$bf
	in a,(6)
	dec a
	out (6),a
	cp $41
	jr z,load_stage3
load_sourceok:
	bit 6,d
	jr nz,load_destok
	ld d,$7f
	in a,(5)
	dec a
	out (5),a
load_destok:
	ldd
	jr load_shiftloop

load_stage3:
	;** stage 3 -- copy saved data to bottom of memory **
	ld hl,$8010
	ld de,$4000
	ld a,$42
	out (5),a
load_filelength:
	ld bc,0
	ldir

	;** stage 4 -- fix the vat **
	ld a,$0d
	out (5),a
	call _RAM_PAGE_7
	ld hl,$bfff

load_adjustloop:
	dec hl
	push hl
	ld e,(hl)
	dec hl
	ld d,(hl)
	dec hl
	ld b,(hl)
load_startpage:
	ld a,0
load_startaddress:
	ld hl,0
	call _cp_ahl_bde
	jr c,load_noadjust
	jr nz,load_notequal
	pop hl
	ld (hl),$00
	dec hl
	ld (hl),$40
	dec hl
	ld (hl),$01
	jr load_adjusted
load_notequal:
	ex de,hl
	ld a,b
	ld de,(load_filelength+1)
	add hl,de
	adc a,0
	ex de,hl
	pop hl
	ld (hl),e
	dec hl
	ld (hl),d
	dec hl
	ld (hl),a
	jr load_adjusted
load_noadjust:
	pop hl
	dec hl
	dec hl
load_adjusted:
	dec hl
	dec hl
	ld b,(hl)
	dec hl
load_dechlloop:
	dec hl
	djnz load_dechlloop
	ex de,hl
	ld hl,($d298)
	or a
	sbc hl,de
	ex de,hl
	jr c,load_adjustloop

load_donereloc:
	;nc if we had to relocate
	ld a,$42
	out (5),a
	jp $4002

load_name:
	.db 5,"blind"
load_waitmessage:
	.db "relocating memory...",0

titlepic:
#include raytitle.lzi

tilegfx:
#include bbtd_tiles.lzi

helpdata:
#include helpdata.lzi
#include rotsprites.asm
#include playergfx.asm

enemy_snake equ 0
enemy_scorp equ 1
enemy_aspidah equ 2
enemy_bspidah equ 3
enemy_monster equ 4
enemy_badguy equ 5
enemy_frog equ 6
enemy_dino equ 7
enemy_bugdude equ 8
enemy_blob equ 9
enemy_zapper equ 10
enemy_someguy equ 11
enemy_swordguy equ 12

enemytable:
	.dw rel(g_snake)
	.dw rel(g_scorp)
	.dw rel(g_aspidah)
	.dw rel(g_bspidah)
	.dw rel(g_monster)
	.dw rel(g_badguy)
	.dw rel(g_frog)
	.dw rel(g_dino)
	.dw rel(g_bugdude)
	.dw rel(g_blob)
	.dw rel(g_zapper)
	.dw rel(g_someguy)
	.dw rel(g_swordguy)

g_snake:
#include snakegfx.lzi
g_scorp:
#include zcross_scorp.lzi
g_aspidah:
#include aspidah.lzi
g_bspidah:
#include bspidah.lzi
g_monster:
#include monstergfx.lzi
g_badguy:
#include badguy.lzi
g_frog:
#include zcross_frog.lzi
g_dino:
#include zcross_dino.lzi
g_bugdude:
#include zcross_bugdude.lzi
g_blob:
#include zcross_blob.lzi
g_zapper:
#include zcross_zapper.lzi
g_someguy:
#include zcross_someguy.lzi
g_swordguy:
#include zcross_swordguy.lzi